classdef CCrossSection < handle
    %CCROSSSECTION Cross section class for use in CFitScenario    
    
    properties
        Spectrum % A CSpectrum class containing the spectral data
        Name % string containing the name of this cross-section. Used for linking shift and squeeze
        CoefficientMode % options are 'free', 'fix', 'limit', 'link'
        CoefficientFixValue % Value to fix the coefficient to
        CoefficientLimitValues % 2 element array with limits for coefficient
        CoefficientLinkTo % integer indicating position of cross-section to link to, starting at 1
        
        ShiftMode % options are 'free', 'fix', 'limit', 'link'
        ShiftFixValue % Value to fix the shift to
        ShiftLimitValues % 2 element array with limits for shifting (in channels, not wavelength)
        ShiftLinkTo % string containing the name of the cross-section to link to
        
        SqueezeMode % options are 'free', 'fix', 'limit', 'link'
        SqueezeFixValue % Value to fix the squeeze to
        SqueezeLimitValues % 2 element array with limits for squeeze
        SqueezeLinkTo % string containing the name of the cross-section to link to
    end
    
    methods
        function CS = CCrossSection()
            CS.Spectrum = CSpectrum();
            CS.CoefficientMode = 'free';
            CS.ShiftMode = 'free';
            CS.SqueezeMode = 'free';
        end                
    end
end

