function [ReturnValues, varargout] = runjs(JScriptFileName)
%RUNJS Use this function to run JScript files in DOASISConsole and return
%parameter values. Parameters must be returned from the JScript in xml 
%format, e.g.: <Shift>20.8</Shift><Squeeze>2.35</Squeeze>...
%If used, the second output variable returns the names of the parameters
%corresoponding to the array of returned values.
%Currently only numeric return values are supported.

    [~, cmdout] = system(['"C:\Program Files (x86)\DOASIS\DoasConsole" ' JScriptFileName]);
    Parameter = [];
    Value = [];

    vi = strfind(cmdout, '<');
    k = 1;
    for i = 1:2:length(vi)-1
        j = 1;
        sbfr = [];
        while 1
            newchar = cmdout(vi(i)+j);
            if strcmp(newchar, '>') 
                break;
            else
                sbfr = [sbfr newchar];
                j = j + 1;
            end
        end
        % remove any newline characters from the string:
        sbfr(sbfr == newline) = [];
        Parameter{k} = sbfr; 
        k = k+1;
    end

    k = 1;
    vi = strfind(cmdout, '>');
    for i = 1:length(vi)
        j = 1;
        sbfr = [];
        while 1
            if vi(i) == length(cmdout)
                break;
            end
            newchar = cmdout(vi(i)+j);
            if strcmp(newchar, '<') || vi(i)+j == length(cmdout) 
                break;
            else
                sbfr = [sbfr newchar];
                j = j + 1;
            end
        end
        sbfr(sbfr == newline) = [];
        if ~isempty(sbfr)
            Value(k) = str2double(sbfr); % all values are double precision
            k = k + 1;
        end        
    end
    ReturnValues = zeros(length(Value), 1);
    ReturnParameters = cell(length(Parameter),1);
    for i = 1:length(ReturnValues)
        ReturnValues(i) = Value(i);
        ReturnParameters{i} = Parameter{i};
    end    
    varargout{1} = ReturnParameters;
end

